/**
 * Copyright (C) 2009-2010 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GTK_EXTENSIONS_H
#define GTK_EXTENSIONS_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <gtk/gtk.h>

#include "wk-key-file.h"

void wk_gtk_toggle_button_link_boolean     (GtkToggleButton *btn,
                                            ConfigItem *item);
void wk_gtk_toggle_button_link_not_boolean (GtkToggleButton *btn,
                                            ConfigItem *item);
void wk_gtk_entry_link_string              (GtkEntry *entry,
                                            ConfigItem *item);
void wk_gtk_spin_button_link_int           (GtkSpinButton *btn,
                                            ConfigItem *item);

GtkWidget *wk_gtk_check_button_new           (const gchar *label,
                                              ConfigItem *item,
                                              gboolean r);
GtkWidget *wk_gtk_entry_new                  (ConfigItem *item);
GtkWidget *wk_gtk_spin_button_new_with_range (gdouble min,
                                              gdouble max,
                                              gdouble step,
                                              ConfigItem *item);

#endif /* !GTK_EXTENSIONS_H */
