/**
 * Copyright (C) 2010 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef WK_LOGGER_H
#define WK_LOGGER_H

#ifdef HAVE_SYSLOG_H
#include <syslog.h>
#endif

#ifdef HAVE_STDARG_H
#include <stdarg.h>
#endif

#include <glib-object.h>

G_BEGIN_DECLS

typedef struct _WkLoggerPrivate WkLoggerPrivate;
typedef struct _WkLoggerClass   WkLoggerClass;
typedef struct _WkLogger        WkLogger;

#define WK_TYPE_LOGGER             (wk_logger_get_type ())
#define WK_LOGGER(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), WK_TYPE_LOGGER, WkLogger))
#define WK_LOGGER_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), WK_TYPE_LOGGER, WkLoggerClass))
#define WK_IS_LOGGER(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WK_TYPE_LOGGER))
#define WK_IS_LOGGER_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), WK_TYPE_LOGGER))
#define WK_LOGGER_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), WK_TYPE_LOGGER, WkLoggerClass))

struct _WkLoggerClass
{
    GObjectClass __parent__;
};

struct _WkLogger
{
    GObject __parent__;

    WkLoggerPrivate *priv;
};

GType wk_logger_get_type (void) G_GNUC_CONST G_GNUC_INTERNAL;

GObject *wk_logger_get ();

gboolean wk_logger_write (WkLogger *logger, int priority,
                          const gchar *format, ...);

#define LOG(x,y) wk_logger_write (WK_LOGGER (wk_logger_get ()), LOG_INFO, x, y)

#endif /* !WK_LOGGER_H */
